'use strict';

/* jshint ignore:start */
/**
 * This code was generated by
 * \ / _    _  _|   _  _
 *  | (_)\/(_)(_|\/| |(/_  v1.0.0
 *       /       /
 */
/* jshint ignore:end */

var Q = require('q');  /* jshint ignore:line */
var _ = require('lodash');  /* jshint ignore:line */
var util = require('util');  /* jshint ignore:line */
var Page = require('../../../base/Page');  /* jshint ignore:line */
var deserialize = require(
    '../../../base/deserialize');  /* jshint ignore:line */
var serialize = require('../../../base/serialize');  /* jshint ignore:line */
var values = require('../../../base/values');  /* jshint ignore:line */

var CampaignList;
var CampaignPage;
var CampaignInstance;
var CampaignContext;

/* jshint ignore:start */
/**
 * Initialize the CampaignList
 *
 * PLEASE NOTE that this class contains beta products that are subject to change.
 * Use them with caution.
 *
 * @constructor Twilio.Messaging.V1.CampaignList
 *
 * @param {Twilio.Messaging.V1} version - Version of the resource
 */
/* jshint ignore:end */
CampaignList = function CampaignList(version) {
  /* jshint ignore:start */
  /**
   * @function campaigns
   * @memberof Twilio.Messaging.V1#
   *
   * @param {string} sid - sid of instance
   *
   * @returns {Twilio.Messaging.V1.CampaignContext}
   */
  /* jshint ignore:end */
  function CampaignListInstance(sid) {
    return CampaignListInstance.get(sid);
  }

  CampaignListInstance._version = version;
  // Path Solution
  CampaignListInstance._solution = {};
  CampaignListInstance._uri = `/a2p/Campaigns`;
  /* jshint ignore:start */
  /**
   * Streams CampaignInstance records from the API.
   *
   * This operation lazily loads records as efficiently as possible until the limit
   * is reached.
   *
   * The results are passed into the callback function, so this operation is memory
   * efficient.
   *
   * If a function is passed as the first argument, it will be used as the callback
   * function.
   *
   * @function each
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {object} [opts] - Options for request
   * @param {number} [opts.limit] -
   *         Upper limit for the number of records to return.
   *         each() guarantees never to return more than limit.
   *         Default is no limit
   * @param {number} [opts.pageSize] -
   *         Number of records to fetch per request,
   *         when not set will use the default value of 50 records.
   *         If no pageSize is defined but a limit is defined,
   *         each() will attempt to read the limit with the most efficient
   *         page size, i.e. min(limit, 1000)
   * @param {Function} [opts.callback] -
   *         Function to process each record. If this and a positional
   *         callback are passed, this one will be used
   * @param {Function} [opts.done] -
   *          Function to be called upon completion of streaming
   * @param {Function} [callback] - Function to process each record
   */
  /* jshint ignore:end */
  CampaignListInstance.each = function each(opts, callback) {
    if (_.isFunction(opts)) {
      callback = opts;
      opts = {};
    }
    opts = opts || {};
    if (opts.callback) {
      callback = opts.callback;
    }
    if (_.isUndefined(callback)) {
      throw new Error('Callback function must be provided');
    }

    var done = false;
    var currentPage = 1;
    var currentResource = 0;
    var limits = this._version.readLimits({
      limit: opts.limit,
      pageSize: opts.pageSize
    });

    function onComplete(error) {
      done = true;
      if (_.isFunction(opts.done)) {
        opts.done(error);
      }
    }

    function fetchNextPage(fn) {
      var promise = fn();
      if (_.isUndefined(promise)) {
        onComplete();
        return;
      }

      promise.then(function(page) {
        _.each(page.instances, function(instance) {
          if (done || (!_.isUndefined(opts.limit) && currentResource >= opts.limit)) {
            done = true;
            return false;
          }

          currentResource++;
          callback(instance, onComplete);
        });

        if (!done) {
          currentPage++;
          fetchNextPage(_.bind(page.nextPage, page));
        }
      });

      promise.catch(onComplete);
    }

    fetchNextPage(_.bind(this.page, this, _.merge(opts, limits)));
  };

  /* jshint ignore:start */
  /**
   * Lists CampaignInstance records from the API as a list.
   *
   * If a function is passed as the first argument, it will be used as the callback
   * function.
   *
   * @function list
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {object} [opts] - Options for request
   * @param {number} [opts.limit] -
   *         Upper limit for the number of records to return.
   *         list() guarantees never to return more than limit.
   *         Default is no limit
   * @param {number} [opts.pageSize] -
   *         Number of records to fetch per request,
   *         when not set will use the default value of 50 records.
   *         If no page_size is defined but a limit is defined,
   *         list() will attempt to read the limit with the most
   *         efficient page size, i.e. min(limit, 1000)
   * @param {function} [callback] - Callback to handle list of records
   *
   * @returns {Promise} Resolves to a list of records
   */
  /* jshint ignore:end */
  CampaignListInstance.list = function list(opts, callback) {
    if (_.isFunction(opts)) {
      callback = opts;
      opts = {};
    }
    opts = opts || {};
    var deferred = Q.defer();
    var allResources = [];
    opts.callback = function(resource, done) {
      allResources.push(resource);

      if (!_.isUndefined(opts.limit) && allResources.length === opts.limit) {
        done();
      }
    };

    opts.done = function(error) {
      if (_.isUndefined(error)) {
        deferred.resolve(allResources);
      } else {
        deferred.reject(error);
      }
    };

    if (_.isFunction(callback)) {
      deferred.promise.nodeify(callback);
    }

    this.each(opts);
    return deferred.promise;
  };

  /* jshint ignore:start */
  /**
   * Retrieve a single page of CampaignInstance records from the API.
   *
   * The request is executed immediately.
   *
   * If a function is passed as the first argument, it will be used as the callback
   * function.
   *
   * @function page
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {object} [opts] - Options for request
   * @param {string} [opts.pageToken] - PageToken provided by the API
   * @param {number} [opts.pageNumber] -
   *          Page Number, this value is simply for client state
   * @param {number} [opts.pageSize] - Number of records to return, defaults to 50
   * @param {function} [callback] - Callback to handle list of records
   *
   * @returns {Promise} Resolves to a list of records
   */
  /* jshint ignore:end */
  CampaignListInstance.page = function page(opts, callback) {
    if (_.isFunction(opts)) {
      callback = opts;
      opts = {};
    }
    opts = opts || {};

    var deferred = Q.defer();
    var data = values.of({
      'PageToken': opts.pageToken,
      'Page': opts.pageNumber,
      'PageSize': opts.pageSize
    });

    var promise = this._version.page({uri: this._uri, method: 'GET', params: data});

    promise = promise.then(function(payload) {
      deferred.resolve(new CampaignPage(this._version, payload, this._solution));
    }.bind(this));

    promise.catch(function(error) {
      deferred.reject(error);
    });

    if (_.isFunction(callback)) {
      deferred.promise.nodeify(callback);
    }

    return deferred.promise;
  };

  /* jshint ignore:start */
  /**
   * Retrieve a single target page of CampaignInstance records from the API.
   *
   * The request is executed immediately.
   *
   * If a function is passed as the first argument, it will be used as the callback
   * function.
   *
   * @function getPage
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {string} [targetUrl] - API-generated URL for the requested results page
   * @param {function} [callback] - Callback to handle list of records
   *
   * @returns {Promise} Resolves to a list of records
   */
  /* jshint ignore:end */
  CampaignListInstance.getPage = function getPage(targetUrl, callback) {
    var deferred = Q.defer();

    var promise = this._version._domain.twilio.request({method: 'GET', uri: targetUrl});

    promise = promise.then(function(payload) {
      deferred.resolve(new CampaignPage(this._version, payload, this._solution));
    }.bind(this));

    promise.catch(function(error) {
      deferred.reject(error);
    });

    if (_.isFunction(callback)) {
      deferred.promise.nodeify(callback);
    }

    return deferred.promise;
  };

  /* jshint ignore:start */
  /**
   * create a CampaignInstance
   *
   * @function create
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {object} opts - Options for request
   * @param {string} opts.brandRegistrationSid - A2P BrandRegistration Sid
   * @param {string} opts.useCase - A2P Campaign UseCase.
   * @param {string} opts.description -
   *          A short description of what this SMS campaign does
   * @param {string|list} opts.messageSamples - Message samples
   * @param {boolean} opts.hasEmbeddedLinks -
   *          Indicate that this SMS campaign will send messages that contain links
   * @param {boolean} opts.hasEmbeddedPhone -
   *          Indicates that this SMS campaign will send messages that contain phone numbers
   * @param {string} opts.messagingServiceSid - MessagingService SID
   * @param {function} [callback] - Callback to handle processed record
   *
   * @returns {Promise} Resolves to processed CampaignInstance
   */
  /* jshint ignore:end */
  CampaignListInstance.create = function create(opts, callback) {
    if (_.isUndefined(opts)) {
      throw new Error('Required parameter "opts" missing.');
    }
    if (_.isUndefined(opts.brandRegistrationSid)) {
      throw new Error('Required parameter "opts.brandRegistrationSid" missing.');
    }
    if (_.isUndefined(opts.useCase)) {
      throw new Error('Required parameter "opts.useCase" missing.');
    }
    if (_.isUndefined(opts.description)) {
      throw new Error('Required parameter "opts.description" missing.');
    }
    if (_.isUndefined(opts.messageSamples)) {
      throw new Error('Required parameter "opts.messageSamples" missing.');
    }
    if (_.isUndefined(opts.hasEmbeddedLinks)) {
      throw new Error('Required parameter "opts.hasEmbeddedLinks" missing.');
    }
    if (_.isUndefined(opts.hasEmbeddedPhone)) {
      throw new Error('Required parameter "opts.hasEmbeddedPhone" missing.');
    }
    if (_.isUndefined(opts.messagingServiceSid)) {
      throw new Error('Required parameter "opts.messagingServiceSid" missing.');
    }

    var deferred = Q.defer();
    var data = values.of({
      'BrandRegistrationSid': _.get(opts, 'brandRegistrationSid'),
      'UseCase': _.get(opts, 'useCase'),
      'Description': _.get(opts, 'description'),
      'MessageSamples': serialize.map(_.get(opts, 'messageSamples'), function(e) { return e; }),
      'HasEmbeddedLinks': serialize.bool(_.get(opts, 'hasEmbeddedLinks')),
      'HasEmbeddedPhone': serialize.bool(_.get(opts, 'hasEmbeddedPhone')),
      'MessagingServiceSid': _.get(opts, 'messagingServiceSid')
    });

    var promise = this._version.create({uri: this._uri, method: 'POST', data: data});

    promise = promise.then(function(payload) {
      deferred.resolve(new CampaignInstance(this._version, payload, this._solution.sid));
    }.bind(this));

    promise.catch(function(error) {
      deferred.reject(error);
    });

    if (_.isFunction(callback)) {
      deferred.promise.nodeify(callback);
    }

    return deferred.promise;
  };

  /* jshint ignore:start */
  /**
   * Constructs a campaign
   *
   * @function get
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @param {string} sid - The SID that identifies the resource to fetch
   *
   * @returns {Twilio.Messaging.V1.CampaignContext}
   */
  /* jshint ignore:end */
  CampaignListInstance.get = function get(sid) {
    return new CampaignContext(this._version, sid);
  };

  /* jshint ignore:start */
  /**
   * Provide a user-friendly representation
   *
   * @function toJSON
   * @memberof Twilio.Messaging.V1.CampaignList#
   *
   * @returns Object
   */
  /* jshint ignore:end */
  CampaignListInstance.toJSON = function toJSON() {
    return this._solution;
  };

  CampaignListInstance[util.inspect.custom] = function inspect(depth, options) {
    return util.inspect(this.toJSON(), options);
  };

  return CampaignListInstance;
};


/* jshint ignore:start */
/**
 * Initialize the CampaignPage
 *
 * PLEASE NOTE that this class contains beta products that are subject to change.
 * Use them with caution.
 *
 * @constructor Twilio.Messaging.V1.CampaignPage
 *
 * @param {V1} version - Version of the resource
 * @param {Response<string>} response - Response from the API
 * @param {CampaignSolution} solution - Path solution
 *
 * @returns CampaignPage
 */
/* jshint ignore:end */
CampaignPage = function CampaignPage(version, response, solution) {
  // Path Solution
  this._solution = solution;

  Page.prototype.constructor.call(this, version, response, this._solution);
};

_.extend(CampaignPage.prototype, Page.prototype);
CampaignPage.prototype.constructor = CampaignPage;

/* jshint ignore:start */
/**
 * Build an instance of CampaignInstance
 *
 * @function getInstance
 * @memberof Twilio.Messaging.V1.CampaignPage#
 *
 * @param {CampaignPayload} payload - Payload response from the API
 *
 * @returns CampaignInstance
 */
/* jshint ignore:end */
CampaignPage.prototype.getInstance = function getInstance(payload) {
  return new CampaignInstance(this._version, payload);
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Messaging.V1.CampaignPage#
 *
 * @returns Object
 */
/* jshint ignore:end */
CampaignPage.prototype.toJSON = function toJSON() {
  let clone = {};
  _.forOwn(this, function(value, key) {
    if (!_.startsWith(key, '_') && ! _.isFunction(value)) {
      clone[key] = value;
    }
  });
  return clone;
};

CampaignPage.prototype[util.inspect.custom] = function inspect(depth, options) {
  return util.inspect(this.toJSON(), options);
};


/* jshint ignore:start */
/**
 * Initialize the CampaignContext
 *
 * PLEASE NOTE that this class contains beta products that are subject to change.
 * Use them with caution.
 *
 * @constructor Twilio.Messaging.V1.CampaignInstance
 *
 * @property {string} accountSid - The SID of the Account that created the resource
 * @property {string} messagingServiceSid - MessagingService SID
 * @property {string} brandRegistrationSid - A2P BrandRegistration Sid
 * @property {string} sid - Campaign sid
 * @property {Date} dateCreated -
 *          The ISO 8601 date and time in GMT when the resource was created
 * @property {Date} dateUpdated -
 *          The ISO 8601 date and time in GMT when the resource was last updated
 * @property {string} description -
 *          A short description of what this SMS campaign does
 * @property {string} messageSamples - Message samples
 * @property {campaign.status} status - Campaign status
 * @property {string} failureReason - A reason why campaign registration has failed
 * @property {string} useCase - A2P Campaign UseCase.
 * @property {boolean} hasEmbeddedLinks -
 *          Indicate that this SMS campaign will send messages that contain links
 * @property {boolean} hasEmbeddedPhone -
 *          Indicates that this SMS campaign will send messages that contain phone numbers
 * @property {string} url - The absolute URL of the Campaign resource
 *
 * @param {V1} version - Version of the resource
 * @param {CampaignPayload} payload - The instance payload
 * @param {sid} sid - The SID that identifies the resource to fetch
 */
/* jshint ignore:end */
CampaignInstance = function CampaignInstance(version, payload, sid) {
  this._version = version;

  // Marshaled Properties
  this.accountSid = payload.account_sid; // jshint ignore:line
  this.messagingServiceSid = payload.messaging_service_sid; // jshint ignore:line
  this.brandRegistrationSid = payload.brand_registration_sid; // jshint ignore:line
  this.sid = payload.sid; // jshint ignore:line
  this.dateCreated = deserialize.iso8601DateTime(payload.date_created); // jshint ignore:line
  this.dateUpdated = deserialize.iso8601DateTime(payload.date_updated); // jshint ignore:line
  this.description = payload.description; // jshint ignore:line
  this.messageSamples = payload.message_samples; // jshint ignore:line
  this.status = payload.status; // jshint ignore:line
  this.failureReason = payload.failure_reason; // jshint ignore:line
  this.useCase = payload.use_case; // jshint ignore:line
  this.hasEmbeddedLinks = payload.has_embedded_links; // jshint ignore:line
  this.hasEmbeddedPhone = payload.has_embedded_phone; // jshint ignore:line
  this.url = payload.url; // jshint ignore:line

  // Context
  this._context = undefined;
  this._solution = {sid: sid || this.sid, };
};

Object.defineProperty(CampaignInstance.prototype,
  '_proxy', {
    get: function() {
      if (!this._context) {
        this._context = new CampaignContext(this._version, this._solution.sid);
      }

      return this._context;
    }
});

/* jshint ignore:start */
/**
 * fetch a CampaignInstance
 *
 * @function fetch
 * @memberof Twilio.Messaging.V1.CampaignInstance#
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed CampaignInstance
 */
/* jshint ignore:end */
CampaignInstance.prototype.fetch = function fetch(callback) {
  return this._proxy.fetch(callback);
};

/* jshint ignore:start */
/**
 * remove a CampaignInstance
 *
 * @function remove
 * @memberof Twilio.Messaging.V1.CampaignInstance#
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed CampaignInstance
 */
/* jshint ignore:end */
CampaignInstance.prototype.remove = function remove(callback) {
  return this._proxy.remove(callback);
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Messaging.V1.CampaignInstance#
 *
 * @returns Object
 */
/* jshint ignore:end */
CampaignInstance.prototype.toJSON = function toJSON() {
  let clone = {};
  _.forOwn(this, function(value, key) {
    if (!_.startsWith(key, '_') && ! _.isFunction(value)) {
      clone[key] = value;
    }
  });
  return clone;
};

CampaignInstance.prototype[util.inspect.custom] = function inspect(depth,
    options) {
  return util.inspect(this.toJSON(), options);
};


/* jshint ignore:start */
/**
 * Initialize the CampaignContext
 *
 * PLEASE NOTE that this class contains beta products that are subject to change.
 * Use them with caution.
 *
 * @constructor Twilio.Messaging.V1.CampaignContext
 *
 * @param {V1} version - Version of the resource
 * @param {sid} sid - The SID that identifies the resource to fetch
 */
/* jshint ignore:end */
CampaignContext = function CampaignContext(version, sid) {
  this._version = version;

  // Path Solution
  this._solution = {sid: sid, };
  this._uri = `/a2p/Campaigns/${sid}`;
};

/* jshint ignore:start */
/**
 * fetch a CampaignInstance
 *
 * @function fetch
 * @memberof Twilio.Messaging.V1.CampaignContext#
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed CampaignInstance
 */
/* jshint ignore:end */
CampaignContext.prototype.fetch = function fetch(callback) {
  var deferred = Q.defer();
  var promise = this._version.fetch({uri: this._uri, method: 'GET'});

  promise = promise.then(function(payload) {
    deferred.resolve(new CampaignInstance(this._version, payload, this._solution.sid));
  }.bind(this));

  promise.catch(function(error) {
    deferred.reject(error);
  });

  if (_.isFunction(callback)) {
    deferred.promise.nodeify(callback);
  }

  return deferred.promise;
};

/* jshint ignore:start */
/**
 * remove a CampaignInstance
 *
 * @function remove
 * @memberof Twilio.Messaging.V1.CampaignContext#
 *
 * @param {function} [callback] - Callback to handle processed record
 *
 * @returns {Promise} Resolves to processed CampaignInstance
 */
/* jshint ignore:end */
CampaignContext.prototype.remove = function remove(callback) {
  var deferred = Q.defer();
  var promise = this._version.remove({uri: this._uri, method: 'DELETE'});

  promise = promise.then(function(payload) {
    deferred.resolve(payload);
  }.bind(this));

  promise.catch(function(error) {
    deferred.reject(error);
  });

  if (_.isFunction(callback)) {
    deferred.promise.nodeify(callback);
  }

  return deferred.promise;
};

/* jshint ignore:start */
/**
 * Provide a user-friendly representation
 *
 * @function toJSON
 * @memberof Twilio.Messaging.V1.CampaignContext#
 *
 * @returns Object
 */
/* jshint ignore:end */
CampaignContext.prototype.toJSON = function toJSON() {
  return this._solution;
};

CampaignContext.prototype[util.inspect.custom] = function inspect(depth,
    options) {
  return util.inspect(this.toJSON(), options);
};

module.exports = {
  CampaignList: CampaignList,
  CampaignPage: CampaignPage,
  CampaignInstance: CampaignInstance,
  CampaignContext: CampaignContext
};
